package com.madeu.controller.mobile.mobileinquiry;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobileuserinquiry.MobileUserInquiryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;

@Slf4j
@Controller
public class MobileInquiryController extends ManagerDraftAction{
    @Autowired
    private MobileUserInquiryService mobileUserInquiryService;
//    @Autowired
//    private WebLogHistoryService webLogHistoryService;
    /**
     * 1:1 문의 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/mobileuserinquiry/selectListUserInquiry.do")
    public ModelAndView selectListUserInquiry(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("MobileInquiryController selectListUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!mobileCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
                map = mobileUserInquiryService.selectListUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("MobileInquiryController selectListUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 1:1 문의정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/mobileuserinquiry/selectUserInquiry.do")
    public ModelAndView selectUserInquiry(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("MobileInquiryController selectUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!mobileCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
                map = mobileUserInquiryService.selectUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("MobileInquiryController selectUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 1:1 문의 정보 등록 (고객 등록)
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/mobileuserinquiry/insertUserInquiry.do")
    public ModelAndView insertUserInquiry(HttpSession session,HttpServletRequest request, HttpServletResponse response, MultipartHttpServletRequest file) {
        log.debug("MobileInquiryController insertUserInquiry START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            if(!mobileCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("membershipAccount", String.valueOf(session.getAttribute("mobileLoginId")));
                paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginUserId")));
                map = mobileUserInquiryService.insertUserInquiry(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/mobileuserinquiry/insertUserInquiry.do");
                insertMap.put("func", "insertUserInquiry");
                insertMap.put("funcName", "1:1 문의 등록");
                insertMap.put("service", "mobileUserInquiryService");
                insertMap.put("serviceName", "1:1 문의 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

//                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("MobileInquiryController insertUserInquiry END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}
